/* ***********************************************************
 * This file was automatically generated on 2020-04-07.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.25                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Two relays to switch AC/DC devices
	/// </summary>
	public class BrickletDualRelay : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 26;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Dual Relay Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_STATE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_MONOFLOP = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_MONOFLOP = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SELECTED_STATE = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_MONOFLOP_DONE = 5;



		/// <summary>
		///  This callback is triggered whenever a monoflop timer reaches 0. The
		///  parameter contain the relay (1 or 2) and the current state of the relay
		///  (the state after the monoflop).
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDoneCallback;
		/// <summary>
		/// </summary>
		public delegate void MonoflopDoneEventHandler(BrickletDualRelay sender, byte relay, bool state);

		/// <summary>
		/// </summary>
		public event MonoflopDoneEventHandler MonoflopDone // for backward compatibility
		{
			add { MonoflopDoneCallback += value; }
			remove { MonoflopDoneCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletDualRelay(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_MONOFLOP_DONE] = new CallbackWrapper(OnMonoflopDoneCallback);


			responseExpected[FUNCTION_SET_STATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_MONOFLOP] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_MONOFLOP] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SELECTED_STATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Sets the state of the relays, *true* means on and *false* means off.
		///  For example: (true, false) turns relay 1 on and relay 2 off.
		///  
		///  If you just want to set one of the relays and don't know the current state
		///  of the other relay, you can get the state with <see cref="Tinkerforge.BrickletDualRelay.GetState"/> or you
		///  can use <see cref="Tinkerforge.BrickletDualRelay.SetSelectedState"/>.
		///  
		///  All running monoflop timers will be aborted if this function is called.
		/// </summary>
		public void SetState(bool relay1, bool relay2)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_STATE);
			LEConverter.To((bool)relay1, 8, request);
			LEConverter.To((bool)relay2, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the state of the relays, *true* means on and *false* means off.
		/// </summary>
		public void GetState(out bool relay1, out bool relay2)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_STATE);

			byte[] response = SendRequest(request, 10);

			relay1 = LEConverter.BoolFrom(8, response);
			relay2 = LEConverter.BoolFrom(9, response);
		}

		/// <summary>
		///  The first parameter can be 1 or 2 (relay 1 or relay 2). The second parameter
		///  is the desired state of the relay (*true* means on and *false* means off).
		///  The third parameter indicates the time that the relay should hold
		///  the state.
		///  
		///  If this function is called with the parameters (1, true, 1500):
		///  Relay 1 will turn on and in 1.5s it will turn off again.
		///  
		///  A monoflop can be used as a failsafe mechanism. For example: Lets assume you
		///  have a RS485 bus and a Dual Relay Bricklet connected to one of the slave
		///  stacks. You can now call this function every second, with a time parameter
		///  of two seconds. The relay will be on all the time. If now the RS485
		///  connection is lost, the relay will turn off in at most two seconds.
		/// </summary>
		public void SetMonoflop(byte relay, bool state, long time)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(14, FUNCTION_SET_MONOFLOP);
			LEConverter.To((byte)relay, 8, request);
			LEConverter.To((bool)state, 9, request);
			LEConverter.To((int)time, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns (for the given relay) the current state and the time as set by
		///  <see cref="Tinkerforge.BrickletDualRelay.SetMonoflop"/> as well as the remaining time until the state flips.
		///  
		///  If the timer is not running currently, the remaining time will be returned
		///  as 0.
		/// </summary>
		public void GetMonoflop(byte relay, out bool state, out long time, out long timeRemaining)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_MONOFLOP);
			LEConverter.To((byte)relay, 8, request);

			byte[] response = SendRequest(request, 17);

			state = LEConverter.BoolFrom(8, response);
			time = LEConverter.UIntFrom(9, response);
			timeRemaining = LEConverter.UIntFrom(13, response);
		}

		/// <summary>
		///  Sets the state of the selected relay (1 or 2), *true* means on and *false* means off.
		///  
		///  A running monoflop timer for the selected relay will be aborted if this function is called.
		///  
		///  The other relay remains untouched.
		/// </summary>
		public void SetSelectedState(byte relay, bool state)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(10, FUNCTION_SET_SELECTED_STATE);
			LEConverter.To((byte)relay, 8, request);
			LEConverter.To((bool)state, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnMonoflopDoneCallback(byte[] response)
		{
			if (response.Length != 10)
			{
				return; // silently ignoring callback with wrong length
			}

			byte relay = LEConverter.ByteFrom(8, response);
			bool state = LEConverter.BoolFrom(9, response);
			var handler = MonoflopDoneCallback;

			if (handler != null)
			{
				handler(this, relay, state);
			}
		}
	}
}
