/* ***********************************************************
 * This file was automatically generated on 2020-04-07.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.25                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Measures two DC voltages between -35V and +35V with 24bit resolution each
	/// </summary>
	public class BrickletIndustrialDualAnalogIn : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 249;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Industrial Dual Analog In Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_VOLTAGE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_DEBOUNCE_PERIOD = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_DEBOUNCE_PERIOD = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_SAMPLE_RATE = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SAMPLE_RATE = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_CALIBRATION = 10;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_CALIBRATION = 11;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_ADC_VALUES = 12;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_VOLTAGE = 13;

		private const int CALLBACK_VOLTAGE_REACHED = 14;


		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OFF = 'x';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_OUTSIDE = 'o';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_INSIDE = 'i';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_SMALLER = '<';

		/// <summary>
		/// </summary>
		public const char THRESHOLD_OPTION_GREATER = '>';

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_976_SPS = 0;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_488_SPS = 1;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_244_SPS = 2;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_122_SPS = 3;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_61_SPS = 4;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_4_SPS = 5;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_2_SPS = 6;

		/// <summary>
		/// </summary>
		public const byte SAMPLE_RATE_1_SPS = 7;


		/// <summary>
		///  This callback is triggered periodically with the period that is set by
		///  <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetVoltageCallbackPeriod"/>. The parameter is the voltage of the
		///  channel.
		///  
		///  The <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.VoltageCallback"/> callback is only triggered if the voltage has changed since the
		///  last triggering.
		/// </summary>
		public event VoltageEventHandler VoltageCallback;
		/// <summary>
		/// </summary>
		public delegate void VoltageEventHandler(BrickletIndustrialDualAnalogIn sender, byte channel, int voltage);

		/// <summary>
		/// </summary>
		public event VoltageEventHandler Voltage // for backward compatibility
		{
			add { VoltageCallback += value; }
			remove { VoltageCallback -= value; }
		}

		/// <summary>
		///  This callback is triggered when the threshold as set by
		///  <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetVoltageCallbackThreshold"/> is reached.
		///  The parameter is the voltage of the channel.
		///  
		///  If the threshold keeps being reached, the callback is triggered periodically
		///  with the period as set by <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetDebouncePeriod"/>.
		/// </summary>
		public event VoltageReachedEventHandler VoltageReachedCallback;
		/// <summary>
		/// </summary>
		public delegate void VoltageReachedEventHandler(BrickletIndustrialDualAnalogIn sender, byte channel, int voltage);

		/// <summary>
		/// </summary>
		public event VoltageReachedEventHandler VoltageReached // for backward compatibility
		{
			add { VoltageReachedCallback += value; }
			remove { VoltageReachedCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletIndustrialDualAnalogIn(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 0;

			callbackWrappers[CALLBACK_VOLTAGE] = new CallbackWrapper(OnVoltageCallback);
			callbackWrappers[CALLBACK_VOLTAGE_REACHED] = new CallbackWrapper(OnVoltageReachedCallback);


			responseExpected[FUNCTION_GET_VOLTAGE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.TRUE;
			responseExpected[FUNCTION_GET_DEBOUNCE_PERIOD] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SAMPLE_RATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SAMPLE_RATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_CALIBRATION] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_CALIBRATION] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_ADC_VALUES] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  Returns the voltage for the given channel.
		///  
		///  If you want to get the voltage periodically, it is recommended to use the
		///  <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.VoltageCallback"/> callback and set the period with
		///  <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetVoltageCallbackPeriod"/>.
		/// </summary>
		public int GetVoltage(byte channel)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_VOLTAGE);
			LEConverter.To((byte)channel, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.IntFrom(8, response);
		}

		/// <summary>
		///  Sets the period with which the <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.VoltageCallback"/> callback is triggered
		///  periodically for the given channel. A value of 0 turns the callback off.
		///  
		///  The <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.VoltageCallback"/> callback is only triggered if the voltage has changed since the
		///  last triggering.
		/// </summary>
		public void SetVoltageCallbackPeriod(byte channel, long period)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(13, FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD);
			LEConverter.To((byte)channel, 8, request);
			LEConverter.To((int)period, 9, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the period as set by <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetVoltageCallbackPeriod"/>.
		/// </summary>
		public long GetVoltageCallbackPeriod(byte channel)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD);
			LEConverter.To((byte)channel, 8, request);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the thresholds for the <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.VoltageReachedCallback"/> callback for the given
		///  channel.
		///  
		///  The following options are possible:
		///  
		///  <code>
		///   "Option", "Description"
		///  
		///   "'x'",    "Callback is turned off"
		///   "'o'",    "Callback is triggered when the voltage is *outside* the min and max values"
		///   "'i'",    "Callback is triggered when the voltage is *inside* the min and max values"
		///   "'&lt;'",    "Callback is triggered when the voltage is smaller than the min value (max is ignored)"
		///   "'&gt;'",    "Callback is triggered when the voltage is greater than the min value (max is ignored)"
		///  </code>
		/// </summary>
		public void SetVoltageCallbackThreshold(byte channel, char option, int min, int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(18, FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD);
			LEConverter.To((byte)channel, 8, request);
			LEConverter.To((char)option, 9, request);
			LEConverter.To((int)min, 10, request);
			LEConverter.To((int)max, 14, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the threshold as set by <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetVoltageCallbackThreshold"/>.
		/// </summary>
		public void GetVoltageCallbackThreshold(byte channel, out char option, out int min, out int max)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD);
			LEConverter.To((byte)channel, 8, request);

			byte[] response = SendRequest(request, 17);

			option = LEConverter.CharFrom(8, response);
			min = LEConverter.IntFrom(9, response);
			max = LEConverter.IntFrom(13, response);
		}

		/// <summary>
		///  Sets the period with which the threshold callback
		///  
		///  * <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.VoltageReachedCallback"/>
		///  
		///  is triggered, if the threshold
		///  
		///  * <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetVoltageCallbackThreshold"/>
		///  
		///  keeps being reached.
		/// </summary>
		public void SetDebouncePeriod(long debounce)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(12, FUNCTION_SET_DEBOUNCE_PERIOD);
			LEConverter.To((int)debounce, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the debounce period as set by <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetDebouncePeriod"/>.
		/// </summary>
		public long GetDebouncePeriod()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_DEBOUNCE_PERIOD);

			byte[] response = SendRequest(request, 12);

			return LEConverter.UIntFrom(8, response);
		}

		/// <summary>
		///  Sets the sample rate. The sample rate can be between 1 sample per second
		///  and 976 samples per second. Decreasing the sample rate will also decrease the
		///  noise on the data.
		/// </summary>
		public void SetSampleRate(byte rate)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_SAMPLE_RATE);
			LEConverter.To((byte)rate, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the sample rate as set by <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetSampleRate"/>.
		/// </summary>
		public byte GetSampleRate()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SAMPLE_RATE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets offset and gain of MCP3911 internal calibration registers.
		///  
		///  See MCP3911 datasheet 7.7 and 7.8. The Industrial Dual Analog In Bricklet
		///  is already factory calibrated by Tinkerforge. It should not be necessary
		///  for you to use this function
		/// </summary>
		public void SetCalibration(int[] offset, int[] gain)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(24, FUNCTION_SET_CALIBRATION);
			LEConverter.To((int[])offset, 8, 2, request);
			LEConverter.To((int[])gain, 16, 2, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the calibration as set by <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetCalibration"/>.
		/// </summary>
		public void GetCalibration(out int[] offset, out int[] gain)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_CALIBRATION);

			byte[] response = SendRequest(request, 24);

			offset = LEConverter.IntArrayFrom(8, response, 2);
			gain = LEConverter.IntArrayFrom(16, response, 2);
		}

		/// <summary>
		///  Returns the ADC values as given by the MCP3911 IC. This function
		///  is needed for proper calibration, see <see cref="Tinkerforge.BrickletIndustrialDualAnalogIn.SetCalibration"/>.
		/// </summary>
		public int[] GetADCValues()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_ADC_VALUES);

			byte[] response = SendRequest(request, 16);

			return LEConverter.IntArrayFrom(8, response, 2);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnVoltageCallback(byte[] response)
		{
			if (response.Length != 13)
			{
				return; // silently ignoring callback with wrong length
			}

			byte channel = LEConverter.ByteFrom(8, response);
			int voltage = LEConverter.IntFrom(9, response);
			var handler = VoltageCallback;

			if (handler != null)
			{
				handler(this, channel, voltage);
			}
		}

		/// <summary>
		/// </summary>
		protected void OnVoltageReachedCallback(byte[] response)
		{
			if (response.Length != 13)
			{
				return; // silently ignoring callback with wrong length
			}

			byte channel = LEConverter.ByteFrom(8, response);
			int voltage = LEConverter.IntFrom(9, response);
			var handler = VoltageReachedCallback;

			if (handler != null)
			{
				handler(this, channel, voltage);
			}
		}
	}
}
