/* ***********************************************************
 * This file was automatically generated on 2020-04-07.      *
 *                                                           *
 * LabVIEW Bindings Version 2.1.25                           *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Controls remote mains switches
	/// </summary>
	public class BrickletRemoteSwitch : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>.
		/// </summary>
		public static int DEVICE_IDENTIFIER = 235;

		/// <summary>
		///  The display name of this device.
		/// </summary>
		public static string DEVICE_DISPLAY_NAME = "Remote Switch Bricklet";

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_SWITCHING_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SET_REPEATS = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_REPEATS = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET_A = 6;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET_B = 7;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_DIM_SOCKET_B = 8;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET_C = 9;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.Device.GetResponseExpected"/> and
		///  <see cref="Tinkerforge.Device.SetResponseExpected"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;

		private const int CALLBACK_SWITCHING_DONE = 3;


		/// <summary>
		/// </summary>
		public const byte SWITCH_TO_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte SWITCH_TO_ON = 1;

		/// <summary>
		/// </summary>
		public const byte SWITCHING_STATE_READY = 0;

		/// <summary>
		/// </summary>
		public const byte SWITCHING_STATE_BUSY = 1;


		/// <summary>
		///  This callback is triggered whenever the switching state changes
		///  from busy to ready, see <see cref="Tinkerforge.BrickletRemoteSwitch.GetSwitchingState"/>.
		/// </summary>
		public event SwitchingDoneEventHandler SwitchingDoneCallback;
		/// <summary>
		/// </summary>
		public delegate void SwitchingDoneEventHandler(BrickletRemoteSwitch sender);

		/// <summary>
		/// </summary>
		public event SwitchingDoneEventHandler SwitchingDone // for backward compatibility
		{
			add { SwitchingDoneCallback += value; }
			remove { SwitchingDoneCallback -= value; }
		}

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletRemoteSwitch(string uid, IPConnection ipcon) : base(uid, ipcon, DEVICE_IDENTIFIER, DEVICE_DISPLAY_NAME)
		{
			apiVersion[0] = 2;
			apiVersion[1] = 0;
			apiVersion[2] = 1;

			callbackWrappers[CALLBACK_SWITCHING_DONE] = new CallbackWrapper(OnSwitchingDoneCallback);


			responseExpected[FUNCTION_SWITCH_SOCKET] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SWITCHING_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_REPEATS] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_REPEATS] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SWITCH_SOCKET_A] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SWITCH_SOCKET_B] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_DIM_SOCKET_B] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_SWITCH_SOCKET_C] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;

			ipcon.AddDevice(this);
		}

		/// <summary>
		///  This function is deprecated, use <see cref="Tinkerforge.BrickletRemoteSwitch.SwitchSocketA"/> instead.
		/// </summary>
		public void SwitchSocket(byte houseCode, byte receiverCode, byte switchTo)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET);
			LEConverter.To((byte)houseCode, 8, request);
			LEConverter.To((byte)receiverCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the current switching state. If the current state is busy, the
		///  Bricklet is currently sending a code to switch a socket. It will not
		///  accept any requests to switch sockets until the state changes to ready.
		///  
		///  How long the switching takes is dependent on the number of repeats, see
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetRepeats"/>.
		/// </summary>
		public byte GetSwitchingState()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SWITCHING_STATE);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the number of times the code is sent when one of the switch socket
		///  functions is called. The repeats basically correspond to the amount of time
		///  that a button of the remote is pressed.
		///  
		///  Some dimmers are controlled by the length of a button pressed,
		///  this can be simulated by increasing the repeats.
		/// </summary>
		public void SetRepeats(byte repeats)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(9, FUNCTION_SET_REPEATS);
			LEConverter.To((byte)repeats, 8, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the number of repeats as set by <see cref="Tinkerforge.BrickletRemoteSwitch.SetRepeats"/>.
		/// </summary>
		public byte GetRepeats()
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REPEATS);

			byte[] response = SendRequest(request, 9);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  To switch a type A socket you have to give the house code, receiver code and the
		///  state (on or off) you want to switch to.
		///  
		///  A detailed description on how you can figure out the house and receiver code
		///  can be found :ref:`here &lt;remote_switch_bricklet_type_a_house_and_receiver_code&gt;`.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SwitchSocketA(byte houseCode, byte receiverCode, byte switchTo)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET_A);
			LEConverter.To((byte)houseCode, 8, request);
			LEConverter.To((byte)receiverCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  To switch a type B socket you have to give the address, unit and the state
		///  (on or off) you want to switch to.
		///  
		///  To switch all devices with the same address use 255 for the unit.
		///  
		///  A detailed description on how you can teach a socket the address and unit can
		///  be found :ref:`here &lt;remote_switch_bricklet_type_b_address_and_unit&gt;`.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SwitchSocketB(long address, byte unit, byte switchTo)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(14, FUNCTION_SWITCH_SOCKET_B);
			LEConverter.To((int)address, 8, request);
			LEConverter.To((byte)unit, 12, request);
			LEConverter.To((byte)switchTo, 13, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  To control a type B dimmer you have to give the address, unit and the
		///  dim value you want to set the dimmer to.
		///  
		///  A detailed description on how you can teach a dimmer the address and unit can
		///  be found :ref:`here &lt;remote_switch_bricklet_type_b_address_and_unit&gt;`.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void DimSocketB(long address, byte unit, byte dimValue)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(14, FUNCTION_DIM_SOCKET_B);
			LEConverter.To((int)address, 8, request);
			LEConverter.To((byte)unit, 12, request);
			LEConverter.To((byte)dimValue, 13, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  To switch a type C socket you have to give the system code, device code and the
		///  state (on or off) you want to switch to.
		///  
		///  A detailed description on how you can figure out the system and device code
		///  can be found :ref:`here &lt;remote_switch_bricklet_type_c_system_and_device_code&gt;`.
		///  
		///  .. versionadded:: 2.0.1$nbsp;(Plugin)
		/// </summary>
		public void SwitchSocketC(char systemCode, byte deviceCode, byte switchTo)
		{
			CheckValidity();

			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET_C);
			LEConverter.To((char)systemCode, 8, request);
			LEConverter.To((byte)deviceCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request, 0);

		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to,
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
		///  The Raspberry Pi HAT (Zero) Brick is always at position 'i' and the Bricklet
		///  connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always as
		///  position 'z'.
		///  
		///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
		///  |device_identifier_constant|
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request, 33);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnSwitchingDoneCallback(byte[] response)
		{
			if (response.Length != 8)
			{
				return; // silently ignoring callback with wrong length
			}

			var handler = SwitchingDoneCallback;

			if (handler != null)
			{
				handler(this);
			}
		}
	}
}
